[LeetCode] Wiggle Subsequence

来源:互联网 发布:ipad如何登陆淘宝卖家 编辑:程序博客网 时间:2024/06/07 13:09

A sequence of numbers is called a wiggle sequence if the differences between successive numbers strictly alternate between positive and negative. The first difference (if one exists) may be either positive or negative. A sequence with fewer than two elements is trivially a wiggle sequence.

For example, [1,7,4,9,2,5] is a wiggle sequence because the differences (6,-3,5,-7,3) are alternately positive and negative. In contrast, [1,4,7,2,5] and [1,7,4,5,5] are not wiggle sequences, the first because its first two differences are positive and the second because its last difference is zero.

Given a sequence of integers, return the length of the longest subsequence that is a wiggle sequence. A subsequence is obtained by deleting some number of elements (eventually, also zero) from the original sequence, leaving the remaining elements in their original order.

Examples:

Input: [1,7,4,9,2,5]Output: 6The entire sequence is a wiggle sequence.Input: [1,17,5,10,13,15,10,5,16,8]Output: 7There are several subsequences that achieve this length. One is [1,17,10,13,10,16,8].Input: [1,2,3,4,5,6,7,8,9]Output: 2

Follow up:

Can you do it in O(n) time?

dp:

方法一:

public class Solution {//两层循环  dp  很不好的算法    public int wiggleMaxLength(int[] nums) {        if(nums.length<=1) return nums.length;        int[] dp1=new int[nums.length];//大于上一个        int[] dp2=new int[nums.length];//小于上一个        dp1[0]=dp2[0]=1;        int max=1;        for(int i=0;i<nums.length;i++){        for(int j=0;j<i;j++){        if(nums[j]>nums[i]){        dp2[i]=Math.max(dp1[j]+1,dp2[i]);        }else if(nums[j]<nums[i]){        dp1[i]=Math.max(dp2[j]+1,dp1[i]);        }        }        max=Math.max(max,Math.max(dp1[i],dp2[i]));        }        return max;    }}

方法二:

public class Solution2 {//由于大小关系的传递性 根本没有必要动态规划public int wiggleMaxLength(int[] nums) {if(nums.length<=1) return nums.length;int dp1=1;//当前比上一个候选者大的时候的最长串  上一个候选者不一定是第i-1个int dp2=1;//同理for(int i=1;i<nums.length;i++){if(nums[i]>nums[i-1]) dp1=dp2+1;else if(nums[i]<nums[i-1]) dp2=dp1+1;}return Math.max(dp1,dp2);}//1,3,2,1,4//dp1 1 2 2 2 4//dp2 1 1 3 3 3}